



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>async await详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">async await详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 11:05:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p><code>async await</code>本身就是<code>promise + generator</code>的语法糖。</p></blockquote>
<p>本文主要讲述以下内容</p>
<ol><li>async awiat 实质</li>
<li>async await 主要特性</li></ol>
<h3>async await 实质</h3>
<p>下面使用 promise + generate 实现 async await</p>
<pre class="prettyprint linenums"><code>    // 转换目标 async1<br />
    // async function async1() {<br />
    //    console.log('async1 start');<br />
    //    await async2();<br />
    //    console.log('async1 end');<br />
    // }

    function async1() {<br />
        // 将 async 转换成 *，将 awiat 转换成 yield<br />
        var awaitInstance = (function* () {<br />
            console.log('async1 start');<br />
            yield async2();<br />
            console.log('async1 end');<br />
        })()

        // 自动执行 await 及后续代码<br />
        // 简单起见，不处理异常情况<br />
        function step() {<br />
            var next = awaitInstance.next();<br />
            // 使用Promise获取 异步/同步 方法的结果，再执行下一步<br />
            Promise.resolve(next.value).then(function (val) {<br />
                if (!next.done) step();<br />
            })<br />
        }<br />
        step();

        // 返回Promise<br />
        return Promise.resolve(undefined);<br />
    }<br />
</code></pre>
<h3>async await 特性</h3>
<ol><li>async 一定会返回 promise</li></ol>
<pre class="prettyprint linenums"><code>    // 案例1： 不设置return<br />
    async function fn() {}<br />
    fn().then(alert); // alert -&gt; undefined

    // 案例2：return非promise<br />
    async function f() {<br />
        return 1<br />
    }<br />
    f().then(alert); // alert -&gt; 1

    // 案例3： return Promise<br />
    async function fn() {<br />
        return Promise.resolve(2);<br />
    }<br />
    fn().then(alert); // alert -&gt; 2<br />
</code></pre>
<ol><li>async 中代码是直接执行的（同步任务）</li></ol>
<pre class="prettyprint linenums"><code>    console.log(1);

    async function fn() {<br />
        console.log(2);<br />
        await console.log(3)<br />
        console.log(4)<br />
     }<br />
    fn();

    console.log(5);

    // 打印 1 2 3 5 4<br />
    // 为何后面是 3 5 4 ? 往下看<br />
</code></pre>
<ol><li>await是直接执行的，而await后面的代码是 microtask。</li></ol>
<pre class="prettyprint linenums"><code>    async function async1() {<br />
        console.log('async1 start');<br />
        await async2();<br />
        console.log('async1 end');<br />
    }

    // 类似于<br />
    async function async1() {<br />
        console.log('async1 start');<br />
        Promise.resolve(async2()).then(() =&gt; {<br />
            console.log('async1 end');<br />
        })<br />
    }<br />
</code></pre>
<ol><li>await后面代码会等await内部代码全部完成后再执行</li></ol>
<pre class="prettyprint linenums"><code>    async function async1() {<br />
        console.log('async1 start');<br />
        await async2();<br />
        console.log('async1 end');<br />
    }

    async function async2() {<br />
        return new Promise(function(resolve) {<br />
            setTimeout(function() {<br />
                console.log('sleep 2s');<br />
                resolve('do');<br />
            }, 2000)<br />
        })<br />
    }

    async1();

    // 打印结果<br />
    // async1 start -&gt; sleep 2s -&gt; async1 end<br />
</code></pre>
<ol><li>await  操作符用于等待一个Promise 对象。它只能在异步函数 async function 中使用。参考 <a href="https://developer.mozilla.org/zh-CN/docs/Web/JavaScript/Reference/Operators/await" rel="external nofollow noreferrer">MDN</a></li></ol>
<pre class="prettyprint linenums"><code>    附：<br />
    在chrome版本 73.0.3683.86（64 位）中,<br />
    await是可以直接使用的。

    var x = await console.log(1)<br />
</code></pre>
<h2>End</h2>
<blockquote><p>持续更新中 <a href="https://github.com/zhongmeizhi/" rel="external nofollow noreferrer">来Github 点颗⭐吧</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m7dp8k.html">java笔记--笔试中极容易出错的表达式的陷阱</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zel7d8.html">一个疑难杂症 IIS URL区分大小写（FF的自动变换URL问题）？</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4jm1q.html">JS 节流</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vepen8.html">10个实用的但偏执的Java编程技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmw4xe9.html">十、mysql事务的简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnrn4z8.html">RabbitMQ 原文译06--Remote procedure call&lpar;RPC&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjo50y9.html">Python之路&comma;Day16 - Django 进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ovoyn9.html">poj 2251 Dungeon Master（bfs）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1w3gmq.html">【分享】如何使用sublime代码片段快速输入PHP头部版本声明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjlejx8.html">css3特效样式库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1zvg9.html">习题9-4 uva 1630</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zkwoj9.html">展开被 SpringBoot 玩的日子 《 四 》 Session 会话共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jylo0q.html">MySQL-count&lpar;&ast;&rpar;和count&lpar;1&rpar;的查询区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwzyez9.html">bootstrap  前端模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2k7epq.html">因微信SSJD分享接口升级，分享变化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o3r4k8.html">aop 记录用户操作（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2xwmx9.html">centos rpm包下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvezy3x9.html">python 删除元组元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v40p5q.html">用as3&period;0制作一个滚动条组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko4y57q.html">Objective-C&colon;MRC手动释放对象内存举例&lpar;引用计数器&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jzolll8.html">es6学习笔记-class之继承</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj6ymlq.html">用Docker解决坑爹的环境搭建系列&mdash;&mdash;ubuntu16&period;04 SSH</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd4vy79.html">openlayers4 入门开发系列之地图标绘篇（附源码下载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpyx3xq.html">openlayers4 入门开发系列之地图属性查询篇（附源码下载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jzvjx8.html">还在用AIDL吗？试试EasyMessenger吧</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg2mwd8.html">RMAN优缺点及RMAN备份及恢复步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z53vx9.html">清理buffer&sol;cache&sol;swap的方法梳理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd4e579.html">SQL Server的Linked Server支持使用SEQUENCE吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpy1j0q.html">Java枚举储存的一种索引实现方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj6pwxq.html">iOS开发之虾米音乐频道选择切换效果分析与实现</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
